//+------------------------------------------------------------------+
//|                                                   BlessingMA.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
//---- indicator settings
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- indicator parameters
extern string   LabelMA      = "MA Entry Settings:";
extern int      MAPeriod     = 100; // Period of MA (H4 = 100, H1 = 400)
extern double   MADistance   = 10;  // Distance from MA to be treated as Ranging Market

//---- indicator buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//----
int ExtCountedBars=0;

double Poin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //Checking for unconvetional Point digits number
   if (Point == 0.00001) Poin = 0.0001; //5 digits
   else if (Point == 0.001) Poin = 0.01; //3 digits
   else Poin = Point; //Normal
   int    draw_begin;
   string short_name;
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   
   draw_begin=MAPeriod-1;
//---- indicator short name
   IndicatorShortName("B3MA("+MAPeriod+")");
   SetIndexLabel(0,"B3MA("+MAPeriod+")Upper");
   SetIndexLabel(1,"B3MA("+MAPeriod+")Lower");
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   if(Bars<=MAPeriod) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   limit=Bars-ExtCountedBars;
//---- EnvelopesM counted in the buffers
   for(int i=0; i<limit; i++)
     { 
      ExtMapBuffer1[i] = iMA(Symbol(),0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,i)+NormalizeDouble(MADistance*Poin,Digits);
      ExtMapBuffer2[i] = iMA(Symbol(),0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,i)-NormalizeDouble(MADistance*Poin,Digits);
     }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+